#!/usr/bin/python3
import os
import argparse

pattern_1 = b"\x11\x42\x91\x50\x7F\xB4\x6C\xAA\x75\x5E\x8D"
pattern_2 = b"\x73\x77\x80\x69\x41\x42\x4A\x50"

def find_pattern(file): 
    hex_key = 0
    enc_data = 0
    with open(file, "rb") as f:
        data = f.read()
        
    pattern_start_1 = data.find(pattern_1)
    pattern_start_2 = data.find(pattern_2)
    
    if pattern_start_1 > 0:
        hex_key = 0xA0
        pattern_size = len(pattern_1)
        magic_header = pattern_1
        pattern_start = pattern_start_1
    elif pattern_start_2 > 0:
        hex_key = 0xE4
        pattern_size = len(pattern_2)
        magic_header = pattern_2
        pattern_start = pattern_start_2
    else:
        return hex_key, enc_data
    
    enc_data = data[pattern_start + pattern_size:]
    return hex_key, enc_data
        
def decrypt(input_file):
    hex_key, enc_payload = find_pattern(input_file)
    
    if hex_key and enc_payload:        
        filename = os.path.basename(input_file)
        dec_stream = b""
        for index,_ in enumerate(enc_payload):
            b = enc_payload[index] ^ hex_key
            b = (b - index) % 256
            dec_stream += bytes([b])

        with open("decrypted_{}.bin".format(filename), "wb") as dec_file:
            dec_file.write(dec_stream)
            
        print("[OK] {} has been decrypted.".format(filename))
    else:
        print("[ERROR] Magic header not found in {}".format(input_file))

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Netdooka Dropper payload extractor.")
    group = parser.add_mutually_exclusive_group(required=True)
    group.add_argument("-f", "--file", type=str, help="Path to NetDooka Dropper file. E.g: <PATH>\file.exe")
    group.add_argument("-d", "--dir", type=str, help="Path to NetDooka Dropper directoy. E.g: <PATH>")
    args = parser.parse_args()

    if args.file:
        decrypt(args.file)
    if args.dir:
        file_list = []
        for dirpath,_,filenames in os.walk(args.dir):
            for f in filenames:
                file_list.append(os.path.abspath(os.path.join(dirpath, f))) 
        for f in file_list:
            decrypt(f)